program Item_2;

{$APPTYPE CONSOLE}

{
  TObject = class
    constructor Create;
    procedure Free;
    function ClassType: TClass;
    class function ClassName: ShortString;
    class function ClassNameIs(const Name: string): Boolean;
    class function InstanceSize: Longint;
    class function InheritsFrom(AClass: TClass): Boolean;
    destructor Destroy; virtual;
  end;
}

uses  SysUtils;

type

  T0 = class(TObject)
    m1: integer;
    m2: integer;
    m3: integer;
  end;

  T1 = class(TObject)
    m1: integer;
  end;

  T2 = class(T1)
    m2: integer;
  end;

var V0 : TObject;
    V1 : T1;
    V2 : T2;

    V3 : T0;
begin

  V3:= T0.Create;
  // 
  V3.m1:= 1;
  V3.m2:= 2;
  V3.m3:= 3;
  //   :
  with V3 do begin
    m1:= 1;
    m2:= 2;
    m3:= 3;
  end;

  try
    V0:= TObject.Create;
    V1:= T1.Create;
    V2:= T2.Create;

    Writeln(V0.ClassType = TObject);  // true
    Writeln(V1.ClassType = TObject);  // false
    Writeln(V2.ClassType = TObject);  // false
    Writeln('- - -');
    Writeln(V0.ClassType = T1);  // false
    Writeln(V1.ClassType = T1);  // true
    Writeln(V2.ClassType = T1);  // false
    Writeln('- - -');
    Writeln(V0.InheritsFrom(TObject));  // true
    Writeln(V1.InheritsFrom(TObject));  // true
    Writeln(V2.InheritsFrom(TObject));  // true
    Writeln('- - -');
    Writeln(V0.InheritsFrom(T1));  // false
    Writeln(V1.InheritsFrom(T1));  // true
    Writeln(V2.InheritsFrom(T1));  // true
    Writeln('- - -');
    Writeln(V0.InheritsFrom(T2));  // false
    Writeln(V1.InheritsFrom(T2));  // false
    Writeln(V2.InheritsFrom(T2));  // true
    Writeln('- - - - - - -');

    Writeln(V0 is TObject);  // true
    Writeln(V1 is TObject);  // true
    Writeln(V2 is TObject);  // true
    Writeln('- - -');
    Writeln(V0 is T1);  // false
    Writeln(V1 is T1);  // true
    Writeln(V2 is T1);  // true
    Writeln('- - -');
    Writeln(V0 is T2);  // false
    Writeln(V1 is T2);  // false
    Writeln(V2 is T2);  // true
    Writeln('- - -');
    Writeln(V1 is V0.ClassType);  // true
    Writeln(V1 is V2.ClassType);  // false

    V0:= V1;

    //V2:= V1;        //   
    V2:= T2(V1);      //  
    //V2:= V1 as T2;  //     EInvalidCast

    Readln;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

